DECLARE SUB flatshade (xp1%, yp1%, zp1%, xp2%, yp2%, zp2%, xp3%, yp3%, zp3%, col%)
DECLARE SUB baline (xx1%, yy1%, cc1%, xx2%, yy2%, cc2%)
DECLARE SUB lighttmap (xp1%, yp1%, zp1%, tpx1!, tpy1!, col1%, xp2%, yp2%, zp2%, tpx2!, tpy2!, col2%, xp3%, yp3%, zp3%, tpx3!, tpy3!, col3%)
DECLARE SUB tmap (xp1%, yp1%, zp1%, tpx1!, tpy1!, xp2%, yp2%, zp2%, tpx2!, tpy2!, xp3%, yp3%, zp3%, tpx3!, tpy3!)
DECLARE SUB phong (xp1%, yp1%, zp1%, nxp1!, nyp1!, nzp1!, xp2%, yp2%, zp2%, nxp2!, nyp2!, nzp2!, xp3%, yp3%, zp3%, nxp3!, nyp3!, nzp3!)
DECLARE SUB gouraudshade (xp1%, yp1%, zp1%, cp1%, xp2%, yp2%, zp2%, cp2%, xp3%, yp3%, zp3%, cp3%)
DECLARE SUB ptmap (xp1%, yp1%, zp1!, tpx1!, tpy1!, xp2%, yp2%, zp2!, tpx2!, tpy2!, xp3%, yp3%, zp3!, tpx3!, tpy3!)
DECLARE SUB makearccos ()
DECLARE SUB Quiksort (min%, max%)
DECLARE SUB pointnormalunits ()
DECLARE SUB pseta3d (x!, y!, z!)
DECLARE SUB pset3d (x%, y%)
DECLARE SUB Inittmap ()
DECLARE SUB nextpal ()
DECLARE SUB rotatepointnormals ()
DECLARE SUB CalcPointNormals ()
DECLARE SUB rotatenormals ()
DECLARE SUB rotatepoints ()
DECLARE SUB CalcNormals ()
DECLARE SUB clearbuf ()
DECLARE SUB bline (xx1%, yy1%, xx2%, yy2%, col%)
DECLARE SUB feedback ()
DECLARE SUB blur ()
DECLARE SUB CenterObject (maxo%)
DECLARE SUB ReadPlgHeader (file$)
DECLARE SUB ReadPlgObject (file$)
DECLARE SUB calc3d (dx%, dy%, dz%)
DECLARE SUB grad (col1%, r1%, g1%, b1%, col2%, r2%, g2%, b2%)
DECLARE SUB pal (colour%, r%, g%, b%)
DECLARE SUB makesins ()
DECLARE FUNCTION lineexists% (p%, p1%, p2%)
DECLARE FUNCTION normcol% (p%)
DECLARE FUNCTION pointnormcol% (p%)
DECLARE FUNCTION pointvis% (p%)
DECLARE FUNCTION polyvis% (p%)

TYPE p3d            'defines a point in 3d
    x AS SINGLE
    y AS SINGLE
    z AS SINGLE
END TYPE

TYPE p2d            'defines a point in 2d
    x AS SINGLE
    y AS SINGLE
END TYPE

TYPE poly           'defines a 3-gon in 3d
    p1 AS INTEGER
    p2 AS INTEGER
    p3 AS INTEGER
END TYPE

DEFINT A-Z

COMMON SHARED points() AS p3d               'each point
COMMON SHARED rotpoints() AS p3d            'each point, rotated
COMMON SHARED pointnormals() AS p3d         'each point's normal
COMMON SHARED rotpointnormals() AS p3d      'each point's rotated normal
COMMON SHARED enviropointnormals() AS p3d   'each point's rotated unit normal
COMMON SHARED polys() AS poly               'each polygon
COMMON SHARED normals() AS p3d              'each polygon's normal
COMMON SHARED rotnormals() AS p3d           'each polygon's rotated normal
COMMON SHARED tmpoints() AS p3d             'each point's tmap point
COMMON SHARED projpoints() AS p2d           'each rotated point's projection
COMMON SHARED avezs() AS INTEGER            'average z-coordinate of poly
COMMON SHARED buffer() AS INTEGER           'buffer
COMMON SHARED zbuf()  AS INTEGER
COMMON SHARED image() AS INTEGER            'texture
COMMON SHARED sins() AS SINGLE              'pre-calced sines
COMMON SHARED coss() AS SINGLE              'pre-calced cosines
COMMON SHARED arccos() AS INTEGER           'pre-calced cosines
COMMON SHARED divs() AS INTEGER             'pre-calced blur divisions
COMMON SHARED mults() AS LONG               'pre-calced multiplications

CONST PI = 3.1415926#

CONST doblur = 1        'blur
CONST dofeedback = 2    'feedback
CONST mpoints = 1       'point
CONST mapoints = 2      'bilinear points
CONST mlines = 3        'wireframe
CONST malines = 4       'antialaised wireframe
CONST mflat = 5         'flatshade
CONST mgouraud = 6      'gouraud shade
CONST mphong = 7        'phong shade
CONST mtmap = 8         'texture map
CONST menviro = 9       'enviroment map
CONST mltmap = 10       'gourauded texture map
CONST mlenviro = 11     'gourauded enviroment map
CONST mptmap = 12       'bilinear gourauded texture map
CONST mpenviro = 13     'bilinear gourauded enviroment map

DIM SHARED segment AS INTEGER
DIM SHARED offset AS INTEGER
DIM SHARED zseg AS INTEGER
DIM SHARED zoff AS INTEGER

DIM SHARED objectname$              'name of object
DIM SHARED numpoints AS INTEGER     'number of points
DIM SHARED numpolys AS INTEGER      'number of polygons

DIM SHARED distance AS INTEGER          'distance to camera
DIM SHARED zoom AS INTEGER              'zoom
DIM SHARED xrot AS INTEGER              'x-rotation
DIM SHARED yrot AS INTEGER              'y-rotation
DIM SHARED zrot AS INTEGER              'z-rotation
DIM SHARED dxr AS INTEGER
DIM SHARED dyr AS INTEGER
DIM SHARED dzr AS INTEGER

DIM SHARED cubex1 AS SINGLE         'control cube coordinates
DIM SHARED cubey1 AS SINGLE         '|
DIM SHARED cubez1 AS SINGLE         '|
DIM SHARED cubex2 AS SINGLE         '|
DIM SHARED cubey2 AS SINGLE         '|
DIM SHARED cubez2 AS SINGLE         '|
DIM SHARED cubex3 AS SINGLE         '|
DIM SHARED cubey3 AS SINGLE         '|
DIM SHARED cubez3 AS SINGLE         '|

DIM SHARED lightx AS SINGLE         'lightsource coordinates
DIM SHARED lighty AS SINGLE         '|
DIM SHARED lightz AS SINGLE         '|
DIM SHARED lightmag AS SINGLE       'lightsource magnitude
DIM SHARED rotlightx AS SINGLE      'rotated lightsource coordinates
DIM SHARED rotlighty AS SINGLE      '|
DIM SHARED rotlightz AS SINGLE      '|
DIM SHARED mode AS INTEGER          'rendering mode
DIM SHARED effect AS INTEGER        'effect mode
DIM SHARED transparent AS INTEGER   'transparency on/off
DIM SHARED bilinear AS INTEGER
DIM SHARED movelight AS INTEGER     'moving light-source on/off
DIM SHARED file$                    'filename
DIM SHARED palnum AS INTEGER        'palette number


makesins
makearccos
CLS
PRINT "3D Rotator"
PRINT " by Entropy"
PRINT
FILES "*.plg"
INPUT "Enter the name of the file to load (enter for teapot):", file$
IF file$ = "" THEN file$ = "teapot.plg"
IF INSTR(file$, ".") = 0 THEN file$ = file$ + ".plg"
PRINT

ReadPlgHeader file$                         'load object header
PRINT "Object "; objectname$; "has"; numpoints; "points and"; numpolys; "polygons"
PRINT "Reading object data...";
REDIM points(numpoints) AS p3d              'redim arrays
REDIM rotpoints(numpoints) AS p3d           '|
REDIM pointnormals(numpoints) AS p3d        '|
REDIM rotpointnormals(numpoints) AS p3d     '|
REDIM enviropointnormals(numpoints) AS p3d  '|
REDIM polys(numpolys) AS poly               '|
REDIM normals(numpolys) AS p3d              '|
REDIM rotnormals(numpolys) AS p3d           '|
REDIM tmpoints(numpoints) AS p3d            '|
REDIM projpoints(numpoints) AS p2d          '|
REDIM avezs(numpolys) AS INTEGER            '|
ReadPlgObject file$                         'load object
PRINT "Done"
PRINT "Centering...";
CenterObject 31                             'center object
PRINT "Done"
PRINT "Calculating normals...";
CalcNormals                                 'calc normals
CalcPointNormals                            'calc point normals
PRINT "Done"
PRINT "Initializing texture maps...";
Inittmap                                    'init texture map
PRINT "Done"
PRINT
PRINT STRING$(80, "-")
PRINT
PRINT "Keys:"
PRINT
PRINT "1   points                               Q/A   x-rotate"
PRINT "2   wireframe                            W/S   y-rotate"
PRINT "3   flat-shade                           E/D   z-rotate"
PRINT "4   gouraud-shade                        +/-   zoom"
PRINT "5   phong-shade                          ,/.   distance farther/closer"
PRINT "6   texture-map                          B/F/N blur/feedback, no effect"
PRINT "7   enviroment-map                       T     transparency on/off"
PRINT "8   gourauded texture-map                M     lightsource moving/stationary"
PRINT "9   gourauded enviroment-map             P     change palette"
PRINT "0   perspective-correct texture-map      R     bilinear on/off"
PRINT "~   perspective-correct enviroment-map"
PRINT
PRINT "Press any key to continue"
DO
LOOP WHILE INKEY$ = ""

SCREEN 13
RANDOMIZE TIMER

REDIM buffer(32001) AS INTEGER      'init buffer
buffer(0) = 2560
buffer(1) = 200
segment = VARSEG(buffer(2))
offset = VARPTR(buffer(2))
REDIM zbuf(32001) AS INTEGER
zbuf(0) = 2560
zbuf(1) = 200
zseg = VARSEG(zbuf(2))
zoff = VARPTR(zbuf(2))

REDIM image(63, 63) AS INTEGER      'load texture
DEF SEG = &HA000
BLOAD "env01.bsv", 0
'BLOAD "images\texture2.put", 0
p = 0
FOR y = 0 TO 63
    FOR x = 0 TO 63
        image(y, x) = PEEK(p)
        'image(y, x) = (PEEK(p) - 16) * 15
        p = p + 1
    NEXT x
NEXT y
DEF SEG

DIM SHARED temp(319) AS INTEGER

REDIM mults(-199 TO 299) AS LONG
FOR m = -199 TO 299            'precalc mults
    mults(m) = 320& * m
NEXT m
REDIM divs(0 TO 1280) AS INTEGER
FOR d = 0 TO 1280           'precalc divs
    divs(d) = INT(d / 5.5)
NEXT d

'Initialize variables
nextpal
mode = 1
effect = 0
distance = 100
zoom = 200
xrot = 0
yrot = 0
zrot = 0
t# = TIMER
frames = 0
fps = 0
starttime# = TIMER
lightangle = 0
lightx = coss(lightangle)
lighty = sins(lightangle)
lightz = -1' coss(lightangle)
lightmag = SQR(lightx * lightx + lighty * lighty + lightz * lightz)

'Begin Main Loop
'-----------------------------------------------------------------------------
DEF SEG = segment
DO
    SELECT CASE UCASE$(INKEY$)              'act upon keypress
        CASE CHR$(27): EXIT DO
        CASE "Q": dxr = dxr + 1
        CASE "A": dxr = dxr - 1
        CASE "W": dyr = dyr + 1
        CASE "S": dyr = dyr - 1
        CASE "E": dzr = dzr + 1
        CASE "D": dzr = dzr - 1
        CASE "B": effect = doblur
        CASE "F": effect = dofeedback
        CASE "N": effect = 0
        CASE "1": mode = mpoints
        CASE "2": mode = mlines
        CASE "3": mode = mflat
        CASE "4": mode = mgouraud
        CASE "5": mode = mphong
        CASE "6": mode = mtmap
        CASE "7": mode = menviro
        CASE "8": mode = mltmap
        CASE "9": mode = mlenviro
        CASE "0": mode = mptmap
        CASE "`": mode = mpenviro
        CASE "\": mode = 0'mspline
        CASE "+": zoom = zoom + 5
        CASE "-": zoom = zoom - 5
        CASE ",": distance = distance + 5
        CASE ".": distance = distance - 5
        CASE "M": movelight = 1 - movelight
        CASE "T": transparent = 1 - transparent
        CASE "R": bilinear = 1 - bilinear
        CASE "P": nextpal
        CASE ELSE
    END SELECT
    IF movelight THEN                               'move light source
        lightangle = (lightangle + 4) MOD 360
        lightx = coss(lightangle)
        lighty = sins(lightangle)
        lightz = -1' coss(lightangle)
        lightmag = SQR(lightx * lightx + lighty * lighty + lightz * lightz)
    END IF
    calc3d dxr, dyr, dzr                'calculate control-cube
    SELECT CASE effect                  'do effects
        CASE doblur: blur
        CASE dofeedback: feedback
        CASE ELSE: clearbuf
    END SELECT
    REDIM zbuf(32001) AS INTEGER
    zbuf(0) = 2560
    zbuf(1) = 200
    rotatepoints
    SELECT CASE mode                    'Render
        CASE mpoints                        'points
            rotatepointnormals
            IF bilinear THEN
                FOR p = 1 TO numpoints
                    IF pointvis(p) OR transparent THEN pseta3d rotpoints(p).x, rotpoints(p).y, rotpoints(p).z
                NEXT p
            ELSE
                FOR p = 1 TO numpoints
                    x = projpoints(p).x
                    y = projpoints(p).y
                    IF pointvis(p) OR transparent THEN pset3d x, y
                NEXT p
            END IF
        CASE mlines                         'wireframe
            rotatenormals
            IF bilinear THEN
                FOR p = 1 TO numpolys
                    p1 = polys(p).p1
                    p2 = polys(p).p2
                    p3 = polys(p).p3
                    x1 = projpoints(p1).x
                    y1 = projpoints(p1).y
                    x2 = projpoints(p2).x
                    y2 = projpoints(p2).y
                    x3 = projpoints(p3).x
                    y3 = projpoints(p3).y
                    IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                        z1 = rotpoints(p1).z
                        z2 = rotpoints(p2).z
                        z3 = rotpoints(p3).z
                        col1 = 127 - z1 * 2
                        col2 = 127 - z2 * 2
                        col3 = 127 - z3 * 2
                        baline x1, y1, col1, x2, y2, col2
                        baline x2, y2, col2, x3, y3, col3
                        baline x3, y3, col3, x1, y1, col1
                    END IF
                NEXT p
            ELSE
                FOR p = 1 TO numpolys
                    x1 = projpoints(polys(p).p1).x
                    y1 = projpoints(polys(p).p1).y
                    x2 = projpoints(polys(p).p2).x
                    y2 = projpoints(polys(p).p2).y
                    x3 = projpoints(polys(p).p3).x
                    y3 = projpoints(polys(p).p3).y
                    IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                        bline x1, y1, x2, y2, 255
                        bline x2, y2, x3, y3, 255
                        bline x3, y3, x1, y1, 255
                    END IF
                NEXT p
            END IF
        CASE mflat                          'flatshade
            rotatenormals
            FOR p = 1 TO numpolys
                p1 = polys(p).p1
                p2 = polys(p).p2
                p3 = polys(p).p3
                x1 = projpoints(p1).x
                y1 = projpoints(p1).y
                x2 = projpoints(p2).x
                y2 = projpoints(p2).y
                x3 = projpoints(p3).x
                y3 = projpoints(p3).y
                IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                    col = normcol(p)
                    z1 = rotpoints(p1).z + distance
                    z2 = rotpoints(p2).z + distance
                    z3 = rotpoints(p3).z + distance
                    flatshade x1, y1, z1, x2, y2, z2, x3, y3, z3, col
                END IF
            NEXT p
        CASE mgouraud                       'gouraud shade
            rotatenormals
            rotatepointnormals
            FOR p = 1 TO numpolys
                p1 = polys(p).p1
                p2 = polys(p).p2
                p3 = polys(p).p3
                x1 = projpoints(p1).x
                y1 = projpoints(p1).y
                x2 = projpoints(p2).x
                y2 = projpoints(p2).y
                x3 = projpoints(p3).x
                y3 = projpoints(p3).y
                IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                    c1 = pointnormcol(p1)
                    c2 = pointnormcol(p2)
                    c3 = pointnormcol(p3)
                    z1 = rotpoints(p1).z + distance
                    z2 = rotpoints(p2).z + distance
                    z3 = rotpoints(p3).z + distance
                    gouraudshade x1, y1, z1, c1, x2, y2, z2, c2, x3, y3, z3, c3
                END IF
            NEXT p
        CASE mphong                         'gouraud shade
            rotatenormals
            rotatepointnormals
            FOR p = 1 TO numpolys
                p1 = polys(p).p1
                p2 = polys(p).p2
                p3 = polys(p).p3
                x1 = projpoints(p1).x
                y1 = projpoints(p1).y
                x2 = projpoints(p2).x
                y2 = projpoints(p2).y
                x3 = projpoints(p3).x
                y3 = projpoints(p3).y
                IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                    nx1! = rotpointnormals(p1).x
                    ny1! = rotpointnormals(p1).y
                    nz1! = rotpointnormals(p1).z
                    nx2! = rotpointnormals(p2).x
                    ny2! = rotpointnormals(p2).y
                    nz2! = rotpointnormals(p2).z
                    nx3! = rotpointnormals(p3).x
                    ny3! = rotpointnormals(p3).y
                    nz3! = rotpointnormals(p3).z
                    z1 = rotpoints(p1).z + distance
                    z2 = rotpoints(p2).z + distance
                    z3 = rotpoints(p3).z + distance
                    phong x1, y1, z1, nx1!, ny1!, nz1!, x2, y2, z2, nx2!, ny2!, nz2!, x3, y3, z3, nx3!, ny3!, nz3!
                END IF
            NEXT p
        CASE mtmap                          'texture-map
            rotatenormals
            FOR p = 1 TO numpolys
                p1 = polys(p).p1
                p2 = polys(p).p2
                p3 = polys(p).p3
                x1 = projpoints(p1).x
                y1 = projpoints(p1).y
                x2 = projpoints(p2).x
                y2 = projpoints(p2).y
                x3 = projpoints(p3).x
                y3 = projpoints(p3).y
                IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                    tx1! = tmpoints(p1).x
                    ty1! = tmpoints(p1).y
                    tx2! = tmpoints(p2).x
                    ty2! = tmpoints(p2).y
                    tx3! = tmpoints(p3).x
                    ty3! = tmpoints(p3).y
                    z1 = rotpoints(p1).z + distance
                    z2 = rotpoints(p2).z + distance
                    z3 = rotpoints(p3).z + distance
                    tmap x1, y1, z1, tx1!, ty1!, x2, y2, z2, tx2!, ty2!, x3, y3, z3, tx3!, ty3!
                END IF
            NEXT p
        CASE menviro                        'enviroment-map
            rotatenormals
            rotatepointnormals
            pointnormalunits
            FOR p = 1 TO numpolys
                p1 = polys(p).p1
                p2 = polys(p).p2
                p3 = polys(p).p3
                x1 = projpoints(p1).x
                y1 = projpoints(p1).y
                x2 = projpoints(p2).x
                y2 = projpoints(p2).y
                x3 = projpoints(p3).x
                y3 = projpoints(p3).y
                IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                    tx1! = enviropointnormals(p1).x
                    ty1! = enviropointnormals(p1).y
                    tx2! = enviropointnormals(p2).x
                    ty2! = enviropointnormals(p2).y
                    tx3! = enviropointnormals(p3).x
                    ty3! = enviropointnormals(p3).y
                    z1 = rotpoints(p1).z + distance
                    z2 = rotpoints(p2).z + distance
                    z3 = rotpoints(p3).z + distance
                    tmap x1, y1, z1, tx1!, ty1!, x2, y2, z2, tx2!, ty2!, x3, y3, z3, tx3!, ty3!
                END IF
            NEXT p
        CASE mltmap                         'texture-map
            rotatenormals
            rotatepointnormals
            FOR p = 1 TO numpolys
                p1 = polys(p).p1
                p2 = polys(p).p2
                p3 = polys(p).p3
                x1 = projpoints(p1).x
                y1 = projpoints(p1).y
                x2 = projpoints(p2).x
                y2 = projpoints(p2).y
                x3 = projpoints(p3).x
                y3 = projpoints(p3).y
                IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                    c1 = pointnormcol(p1)
                    c2 = pointnormcol(p2)
                    c3 = pointnormcol(p3)
                    tx1! = tmpoints(p1).x
                    ty1! = tmpoints(p1).y
                    tx2! = tmpoints(p2).x
                    ty2! = tmpoints(p2).y
                    tx3! = tmpoints(p3).x
                    ty3! = tmpoints(p3).y
                    z1 = rotpoints(p1).z + distance
                    z2 = rotpoints(p2).z + distance
                    z3 = rotpoints(p3).z + distance
                    lighttmap x1, y1, z1, tx1!, ty1!, c1, x2, y2, z2, tx2!, ty2!, c2, x3, y3, z3, tx3!, ty3!, c3
                END IF
            NEXT p
        CASE mlenviro                       'enviroment-map
            rotatenormals
            rotatepointnormals
            pointnormalunits
            FOR p = 1 TO numpolys
                p1 = polys(p).p1
                p2 = polys(p).p2
                p3 = polys(p).p3
                x1 = projpoints(p1).x
                y1 = projpoints(p1).y
                x2 = projpoints(p2).x
                y2 = projpoints(p2).y
                x3 = projpoints(p3).x
                y3 = projpoints(p3).y
                IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                    c1 = pointnormcol(p1)
                    c2 = pointnormcol(p2)
                    c3 = pointnormcol(p3)
                    tx1! = enviropointnormals(p1).x
                    ty1! = enviropointnormals(p1).y
                    tx2! = enviropointnormals(p2).x
                    ty2! = enviropointnormals(p2).y
                    tx3! = enviropointnormals(p3).x
                    ty3! = enviropointnormals(p3).y
                    z1 = rotpoints(p1).z + distance
                    z2 = rotpoints(p2).z + distance
                    z3 = rotpoints(p3).z + distance
                    lighttmap x1, y1, z1, tx1!, ty1!, c1, x2, y2, z2, tx2!, ty2!, c2, x3, y3, z3, tx3!, ty3!, c3
                END IF
            NEXT p
        CASE mptmap                         'texture-map
            rotatenormals
            FOR p = 1 TO numpolys
                p1 = polys(p).p1
                p2 = polys(p).p2
                p3 = polys(p).p3
                x1 = projpoints(p1).x
                y1 = projpoints(p1).y
                x2 = projpoints(p2).x
                y2 = projpoints(p2).y
                x3 = projpoints(p3).x
                y3 = projpoints(p3).y
                IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                    z1! = rotpoints(p1).z + distance
                    tx1! = tmpoints(p1).x
                    ty1! = tmpoints(p1).y
                    z2! = rotpoints(p2).z + distance
                    tx2! = tmpoints(p2).x
                    ty2! = tmpoints(p2).y
                    z3! = rotpoints(p3).z + distance
                    tx3! = tmpoints(p3).x
                    ty3! = tmpoints(p3).y
                    ptmap x1, y1, z1!, tx1!, ty1!, x2, y2, z2!, tx2!, ty2!, x3, y3, z3!, tx3!, ty3!
                END IF
            NEXT p
        CASE mpenviro
            rotatenormals
            rotatepointnormals
            pointnormalunits
            FOR p = 1 TO numpolys
                p1 = polys(p).p1
                p2 = polys(p).p2
                p3 = polys(p).p3
                x1 = projpoints(p1).x
                y1 = projpoints(p1).y
                x2 = projpoints(p2).x
                y2 = projpoints(p2).y
                x3 = projpoints(p3).x
                y3 = projpoints(p3).y
                IF (y1 - y2) * (x2 - x3) > (x1 - x2) * (y2 - y3) OR transparent THEN
                    z1! = rotpoints(p1).z + distance
                    tx1! = enviropointnormals(p1).x
                    ty1! = enviropointnormals(p1).y
                    z2! = rotpoints(p2).z + distance
                    tx2! = enviropointnormals(p2).x
                    ty2! = enviropointnormals(p2).y
                    z3! = rotpoints(p3).z + distance
                    tx3! = enviropointnormals(p3).x
                    ty3! = enviropointnormals(p3).y
                    ptmap x1, y1, z1!, tx1!, ty1!, x2, y2, z2!, tx2!, ty2!, x3, y3, z3!, tx3!, ty3!
                END IF
            NEXT p
        CASE ELSE
    END SELECT
    frames = frames + 1             'find/show frame-rate
    IF TIMER - t# >= 1 THEN
        fps = frames / (TIMER - t#)
        t# = TIMER
        frames = 0
    END IF
    p = offset + 330
    FOR f = 0 TO 25
        POKE p, 255
        p = p + 10
    NEXT f
    POKE offset + fps, 255
    PUT (0, 0), buffer, PSET        'show stuff
LOOP
SCREEN 0
WIDTH 80
PRINT "3D-Rotator"
PRINT "by Entropy"
PRINT "spau0022@tc.umn.edu"
PRINT "http://www.uslink.net/~insty/"
PRINT "ICQ: 52012626"

SUB baline (xx1, yy1, cc1, xx2, yy2, cc2)

x1 = xx1
y1 = yy1
c1 = cc1
x2 = xx2
y2 = yy2
c2 = cc2

IF ABS(x2 - x1) > ABS(y2 - y1) THEN
    IF x2 < x1 THEN
        SWAP x1, x2
        SWAP y1, y2
        SWAP c1, c2
    END IF
    dy! = (y2 - y1) / (x2 - x1)
    y! = y1
    dc! = (c2 - c1) / (x2 - x1)
    c! = c1
    FOR x = x1 TO x2
        IF x > 319 THEN EXIT SUB
        y3 = INT(y!)
        col = INT(c!)
        IF y3 < 199 AND y3 > -1 AND x > -1 THEN
            p& = mults(y3) + x + offset
            IF col < 0 THEN col = 0
            col2 = col * (y! - y3)
            col1 = col - col2 + PEEK(p&)
            col2 = col2 + PEEK(p& + 320)
            IF col1 > 255 THEN col1 = 255
            IF col2 > 255 THEN col2 = 255
            POKE p&, col1
            POKE p& + 320, col2
        END IF
        y! = y! + dy!
        c! = c! + dc!
    NEXT x
ELSE
    IF y2 < y1 THEN
        SWAP x1, x2
        SWAP y2, y1
    END IF
    IF y2 - y1 < 1 THEN
        EXIT SUB
    END IF
    dx! = (x2 - x1) / (y2 - y1)
    x! = x1
    dc! = (c2 - c1) / (y2 - y1)
    c! = c1
    FOR y = y1 TO y2
        IF y > 199 THEN EXIT SUB
        x3 = INT(x!)
        col = INT(c!)
        IF x3 > -1 AND x3 < 319 AND y > -1 THEN
            p& = mults(y) + x3 + offset
            IF col < 0 THEN col = 0
            col2 = col * (x! - x3)
            col1 = col - col2 + PEEK(p&)
            col2 = col2 + PEEK(p& + 1)
            IF col1 > 255 THEN col1 = 255
            IF col2 > 255 THEN col2 = 255
            POKE p&, col1
            POKE p& + 1, col2
        END IF
        x! = x! + dx!
        c! = c! + dc!
    NEXT y
END IF

END SUB

SUB bline (xx1, yy1, xx2, yy2, col)

x1 = xx1
y1 = yy1
x2 = xx2
y2 = yy2

xchng = x2 - x1
ychng = y2 - y1

IF x2 < x1 THEN
    SWAP x2, x1
    SWAP y2, y1
    xchng = -xchng
    ychng = -ychng
END IF
IF ychng < 0 THEN
    ychng = -ychng
    yadd = -1
ELSE
    yadd = 1
END IF
y = y1
IF y > -1 AND y < 200 THEN
    p& = offset + mults(y) + x1
ELSE
    p& = 320& * y + offset + x1
END IF
d = 0
FOR x = x1 TO x2
    IF x > 319 THEN EXIT SUB
    d = d + ychng
    IF d <= xchng THEN
        IF y > -1 AND y < 200 AND x > -1 THEN
            POKE p&, col
        END IF
    ELSE
        WHILE d > xchng
            d = d - xchng
            y = y + yadd
            IF y = y2 + yadd THEN EXIT SUB
            p& = p& + 320 * yadd
            IF y > -1 AND y < 200 AND x > -1 THEN
                POKE p&, col
            END IF
        WEND
    END IF
    p& = p& + 1
NEXT

END SUB

SUB blur

FOR p = offset TO 960 + offset
    POKE p, 0
NEXT p
FOR p& = 961 + offset TO 63678 + offset
    POKE p&, divs(PEEK(p& - 320) + PEEK(p& - 1) + PEEK(p&) + PEEK(p& + 1) + PEEK(p& + 320))
    'POKE p&, divs(PEEK(p&) + PEEK(p& + 319) + PEEK(p& + 320) + PEEK(p& + 321) + PEEK(p&))
NEXT p&
FOR p& = 63680 + offset TO 63999 + offset
    POKE p&, 0
NEXT p&

END SUB

SUB calc3d (dx, dy, dz)

'|(0,1,0)
'|
'|
'|     /(0,0,1)
'|   /
'| /
'+-----------(1,0,0)
'

xrot = (xrot + dx) MOD 360
yrot = (yrot + dy) MOD 360
zrot = (zrot + dz) MOD 360
sx! = sins(xrot)
cx! = coss(xrot)
sy! = sins(yrot)
cy! = coss(yrot)
sz! = sins(zrot)
cz! = coss(zrot)
cubex1 = cy! * cz!
cubey1 = -cy! * sz!
cubez1 = sy!
cubex2 = sx! * sy! * cz! + cx! * sz!
cubey2 = cx! * cz! - sx! * sy! * sz!
cubez2 = -sx! * cy!
cubex3 = sx! * sz! - cx! * sy! * cz!
cubey3 = sx! * cz! + cx! * sy! * sz!
cubez3 = cx! * cy!

END SUB

SUB CalcNormals

FOR p = 1 TO numpolys
    x1! = points(polys(p).p1).x
    y1! = points(polys(p).p1).y
    z1! = points(polys(p).p1).z
    x2! = points(polys(p).p2).x
    y2! = points(polys(p).p2).y
    z2! = points(polys(p).p2).z
    x3! = points(polys(p).p3).x
    y3! = points(polys(p).p3).y
    z3! = points(polys(p).p3).z
    xc1! = x2! - x1!
    yc1! = y2! - y1!
    zc1! = z2! - z1!
    xc2! = x3! - x1!
    yc2! = y3! - y1!
    zc2! = z3! - z1!
    normals(p).x = yc1! * zc2! - zc1! * yc2!
    normals(p).y = zc1! * xc2! - xc1! * zc2!
    normals(p).z = xc1! * yc2! - yc1! * xc2!
    mag! = SQR(normals(p).x ^ 2 + normals(p).y ^ 2 + normals(p).z ^ 2)
    IF mag! = 0 THEN mag! = 1
    normals(p).x = normals(p).x / mag! * 256
    normals(p).y = normals(p).y / mag! * 256
    normals(p).z = normals(p).z / mag! * 256
NEXT p

END SUB

SUB CalcPointNormals

FOR p = 1 TO numpoints
    pointnormals(p).x = 0
    pointnormals(p).y = 0
    pointnormals(p).z = 0
    FOR p2 = 1 TO numpolys
        IF polys(p2).p1 = p OR polys(p2).p2 = p OR polys(p3).p2 = p THEN
            pointnormals(p).x = pointnormals(p).x + normals(p2).x
            pointnormals(p).y = pointnormals(p).y + normals(p2).y
            pointnormals(p).z = pointnormals(p).z + normals(p2).z
        END IF
    NEXT p2
    mag! = SQR(pointnormals(p).x ^ 2 + pointnormals(p).y ^ 2 + pointnormals(p).z ^ 2)
    IF mag! = 0 THEN mag! = 1
    pointnormals(p).x = pointnormals(p).x / mag! * 256
    pointnormals(p).y = pointnormals(p).y / mag! * 256
    pointnormals(p).z = pointnormals(p).z / mag! * 256
NEXT p

END SUB

SUB CenterObject (maxo%)

maxx! = points(1).x
minx! = points(1).x
maxy! = points(1).y
miny! = points(1).y
maxz! = points(1).z
minz! = points(1).z

FOR p = 1 TO numpoints
    IF maxx! < points(p).x THEN maxx! = points(p).x
    IF minx! > points(p).x THEN minx! = points(p).x
    IF maxy! < points(p).y THEN maxy! = points(p).y
    IF miny! > points(p).y THEN miny! = points(p).y
    IF maxz! < points(p).z THEN maxz! = points(p).z
    IF minz! > points(p).z THEN minz! = points(p).z
NEXT

normx! = (maxx! + minx!) / 2
normy! = (maxy! + miny!) / 2
normz! = (maxz! + minz!) / 2
IF maxx! > maxy! THEN s1! = maxx! ELSE s1! = maxy!
IF s1! < maxz! THEN s1! = maxz!
IF s1! <> 0 THEN s2! = maxo% / s1! ELSE s2! = 1

FOR p = 1 TO numpoints
    points(p).x = (points(p).x - normx!) * s2!
    points(p).y = (points(p).y - normy!) * s2!
    points(p).z = (points(p).z - normz!) * s2!
NEXT

END SUB

SUB clearbuf

REDIM buffer(32001) AS INTEGER
buffer(0) = 2560
buffer(1) = 200
REDIM zbuf(32001) AS INTEGER
zbuf(0) = 2560
zbuf(1) = 200

END SUB

SUB feedback

FOR p = offset TO 960 + offset
    POKE p, 0
NEXT p
FOR p& = 961 + offset TO 63678 + offset
    col = PEEK(p&) - 15
    IF col < 0 THEN col = 0
    POKE p&, col
NEXT p&

END SUB

SUB flatshade (xp1, yp1, zp1, xp2, yp2, zp2, xp3, yp3, zp3, col)

IF xp1 <= xp2 THEN
    IF xp1 <= xp3 THEN
        x1 = xp1: y1 = yp1: z1 = zp1
        IF xp2 < xp3 THEN
            x2 = xp2: y2 = yp2: z2 = zp2
            x3 = xp3: y3 = yp3: z3 = zp3
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3
            x3 = xp2: y3 = yp2: z3 = zp2
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3
        x2 = xp1: y2 = yp1: z2 = zp1
        x3 = xp2: y3 = yp2: z3 = zp2
    END IF
ELSE
    IF xp2 <= xp3 THEN
        x1 = xp2: y1 = yp2: z1 = zp2
        IF xp1 < xp3 THEN
            x2 = xp1: y2 = yp1: z2 = zp1
            x3 = xp3: y3 = yp3: z3 = zp3
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3
            x3 = xp1: y3 = yp1: z3 = zp1
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3
        x2 = xp2: y2 = yp2: z2 = zp2
        x3 = xp1: y3 = yp1: z3 = zp1
    END IF
END IF

IF x3 = x1 THEN
    EXIT SUB
ELSE
    invz1! = 1 / z1
    invz2! = 1 / z2
    invz3! = 1 / z3
    xchng1 = x3 - x1
    xchng2 = x2 - x1
    xchng3 = x3 - x2
    yslope1# = (y3 - y1) / xchng1
    yt1# = y1
    izslope1# = (invz3! - invz1!) / xchng1
    iz1# = invz1!
    'izslope1# = (z3 - z1) / xchng1
    'iz1# = z1
    IF xchng2 THEN
        yslope2# = (y2 - y1) / xchng2
        yt2# = y1
        izslope2# = (invz2! - invz1!) / xchng2
        iz2# = invz1!
        'izslope2# = (z2 - z1) / xchng2
        'iz2# = z1
        FOR x = x1 TO x2
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                'izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                'iz# = iz1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        'z = iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            IF transparent THEN
                                'c = col / 2 + PEEK(p&) * .75
                                c = col \ 2 + PEEK(p&)
                                IF c > 255 THEN c = 255
                                POKE p&, c
                            ELSE
                                POKE p&, col
                            END IF
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                NEXT y
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
        NEXT x
    END IF

    IF xchng3 THEN
        yslope2# = (y3 - y2) / xchng3
        yt2# = y2
        izslope2# = (invz3! - invz2!) / xchng3
        iz2# = invz2!
        'izslope2# = (z3 - z2) / xchng3
        'iz2# = z2
        FOR x = x2 + 1 TO x3
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        'z = iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            IF transparent THEN
                                'c = col / 2 + PEEK(p&) * .75
                                c = col \ 2 + PEEK(p&)
                                IF c > 255 THEN c = 255
                                POKE p&, c
                            ELSE
                                POKE p&, col
                            END IF
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                NEXT y
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
        NEXT x
    END IF
END IF

END SUB

SUB gouraudshade (xp1, yp1, zp1, cp1, xp2, yp2, zp2, cp2, xp3, yp3, zp3, cp3)

IF xp1 <= xp2 THEN
    IF xp1 <= xp3 THEN
        x1 = xp1: y1 = yp1: z1 = zp1: c1 = cp1
        IF xp2 < xp3 THEN
            x2 = xp2: y2 = yp2: z2 = zp2: c2 = cp2
            x3 = xp3: y3 = yp3: z3 = zp3: c3 = cp3
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3: c2 = cp3
            x3 = xp2: y3 = yp2: z3 = zp2: c3 = cp2
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3: c1 = cp3
        x2 = xp1: y2 = yp1: z2 = zp1: c2 = cp1
        x3 = xp2: y3 = yp2: z3 = zp2: c3 = cp2
    END IF
ELSE
    IF xp2 <= xp3 THEN
        x1 = xp2: y1 = yp2: z1 = zp2: c1 = cp2
        IF xp1 < xp3 THEN
            x2 = xp1: y2 = yp1: z2 = zp1: c2 = cp1
            x3 = xp3: y3 = yp3: z3 = zp3: c3 = cp3
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3: c2 = cp3
            x3 = xp1: y3 = yp1: z3 = zp1: c3 = cp1
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3: c1 = cp3
        x2 = xp2: y2 = yp2: z2 = zp2: c2 = cp2
        x3 = xp1: y3 = yp1: z3 = zp1: c3 = cp1
    END IF
END IF

IF x3 = x1 THEN
    EXIT SUB
ELSE
    invz1! = 1 / z1
    invz2! = 1 / z2
    invz3! = 1 / z3
    xchng1 = x3 - x1
    xchng2 = x2 - x1
    xchng3 = x3 - x2
    yslope1# = (y3 - y1) / xchng1
    yt1# = y1
    izslope1# = (invz3! - invz1!) / xchng1
    iz1# = invz1!
    cslope1# = (c3 - c1) / xchng1
    ct1# = c1
    IF xchng2 THEN
        yslope2# = (y2 - y1) / xchng2
        yt2# = y1
        izslope2# = (invz2! - invz1!) / xchng2
        iz2# = invz1!
        cslope2# = (c2 - c1) / xchng2
        ct2# = c1
        FOR x = x1 TO x2
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                cslope3# = (ct2# - ct1#) / (iyt2 - iyt1)
                ct3# = ct1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            IF transparent THEN
                                c = ct3# / 2 + PEEK(p&) * .75
                                IF c > 255 THEN c = 255
                                POKE p&, c
                            ELSE
                                POKE p&, ct3#
                            END IF
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    ct3# = ct3# + cslope3# * dy
                NEXT y
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            ct1# = ct1# + cslope1#
            ct2# = ct2# + cslope2#
        NEXT x
    END IF

    IF x3 <> x2 THEN
        yslope2# = (y3 - y2) / xchng3
        yt2# = y2
        izslope2# = (invz3! - invz2!) / xchng3
        iz2# = invz2!
        cslope2# = (c3 - c2) / xchng3
        ct2# = c2
        FOR x = x2 + 1 TO x3
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                cslope3# = (ct2# - ct1#) / (iyt2 - iyt1)
                ct3# = ct1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            IF transparent THEN
                                c = ct3# / 2 + PEEK(p&) * .75
                                IF c > 255 THEN c = 255
                                POKE p&, c
                            ELSE
                                POKE p&, ct3#
                            END IF
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    ct3# = ct3# + cslope3# * dy
                NEXT y
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            ct1# = ct1# + cslope1#
            ct2# = ct2# + cslope2#
        NEXT x
    END IF
END IF

END SUB

SUB grad (col1, r1, g1, b1, col2, r2, g2, b2)

cols = col2 - col1 + 1
rstep# = (r2 - r1) / cols
gstep# = (g2 - g1) / cols
bstep# = (b2 - b1) / cols
r# = r1
g# = g1
b# = b1
FOR col = col1 TO col2
    r# = r# + rstep#
    g# = g# + gstep#
    b# = b# + bstep#
    pal col, CINT(r#), CINT(g#), CINT(b#)
NEXT

END SUB

SUB Inittmap

FOR p = 1 TO numpoints
    'x! = points(p).x
    'y! = points(p).y
    'z! = points(p).z
    'r! = SQR(x! ^ 2 + y! ^ 2 + z! ^ 2)
    'x! = x! / r!
    'y! = y! / r!
    'z! = z! / r!
    'c1 = 0
    'c2 = 360
    'DO
    '    c3 = (c2 + c1) \ 2
    '    c! = coss(c3)
    '    IF c! < z! THEN c2 = c3 ELSE c1 = c3
    'LOOP UNTIL c2 - c1 < 2
    'IF c3 > 180 THEN c3 = 360 - c3
    'tx = c3
    'x! = x! / sins(c3)
    'c1 = 0
    'c2 = 360
    'DO
    '    c3 = (c2 + c1) \ 2
    '    c! = coss(c3)
    '    IF c! < x! THEN c2 = c3 ELSE c1 = c3
    'LOOP UNTIL c2 - c1 < 2
    'IF c3 > 180 THEN c3 = 360 - c3
    'ty = c3
    'tmpoints(p).x = tx / 360 * 64
    'tmpoints(p).y = ty / 360 * 64
    tmpoints(p).x = points(p).x + 32
    tmpoints(p).y = points(p).y + 32
NEXT p

END SUB

SUB lighttmap (xp1, yp1, zp1, tpx1!, tpy1!, col1, xp2, yp2, zp2, tpx2!, tpy2!, col2, xp3, yp3, zp3, tpx3!, tpy3!, col3)

'sort by projected x
IF xp1 <= xp2 THEN
    IF xp1 <= xp3 THEN
        x1 = xp1: y1 = yp1: z1 = zp1: tx1! = tpx1!: ty1! = tpy1!: c1 = col1
        IF xp2 < xp3 THEN
            x2 = xp2: y2 = yp2: z2 = zp2: tx2! = tpx2!: ty2! = tpy2!: c2 = col2
            x3 = xp3: y3 = yp3: z3 = zp3: tx3! = tpx3!: ty3! = tpy3!: c3 = col3
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3: tx2! = tpx3!: ty2! = tpy3!: c2 = col3
            x3 = xp2: y3 = yp2: z3 = zp2: tx3! = tpx2!: ty3! = tpy2!: c3 = col2
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3: tx1! = tpx3!: ty1! = tpy3!: c1 = col3
        x2 = xp1: y2 = yp1: z2 = zp1: tx2! = tpx1!: ty2! = tpy1!: c2 = col1
        x3 = xp2: y3 = yp2: z3 = zp2: tx3! = tpx2!: ty3! = tpy2!: c3 = col2
    END IF
ELSE
    IF xp2 <= xp3 THEN
        x1 = xp2: y1 = yp2: z1 = zp2: tx1! = tpx2!: ty1! = tpy2!: c1 = col2
        IF xp1 < xp3 THEN
            x2 = xp1: y2 = yp1: z2 = zp1: tx2! = tpx1!: ty2! = tpy1!: c2 = col1
            x3 = xp3: y3 = yp3: z3 = zp3: tx3! = tpx3!: ty3! = tpy3!: c3 = col3
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3: tx2! = tpx3!: ty2! = tpy3!: c2 = col3
            x3 = xp1: y3 = yp1: z3 = zp1: tx3! = tpx1!: ty3! = tpy1!: c3 = col1
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3: tx1! = tpx3!: ty1! = tpy3!: c1 = col3
        x2 = xp2: y2 = yp2: z2 = zp2: tx2! = tpx2!: ty2! = tpy2!: c2 = col2
        x3 = xp1: y3 = yp1: z3 = zp1: tx3! = tpx1!: ty3! = tpy1!: c3 = col1
    END IF
END IF

IF x3 = x1 THEN
    EXIT SUB
ELSE
    invz1! = 1 / z1
    invz2! = 1 / z2
    invz3! = 1 / z3
    xchng1 = x3 - x1
    xchng2 = x2 - x1
    xchng3 = x3 - x2
    yslope1# = (y3 - y1) / xchng1
    yt1# = y1
    izslope1# = (invz3! - invz1!) / xchng1
    iz1# = invz1!
    cslope1# = (c3 - c1) / xchng1
    ct1# = c1
    txslope1# = (tx3! - tx1!) / xchng1
    txt1# = tx1!
    tyslope1# = (ty3! - ty1!) / xchng1
    tyt1# = ty1!
    IF x2 > x1 THEN
        yslope2# = (y2 - y1) / xchng2
        yt2# = y1
        izslope2# = (invz2! - invz1!) / xchng2
        iz2# = invz1!
        cslope2# = (c2 - c1) / xchng2
        ct2# = c1
        txslope2# = (tx2! - tx1!) / xchng2
        txt2# = tx1!
        tyslope2# = (ty2! - ty1!) / xchng2
        tyt2# = ty1!
        FOR x = x1 TO x2
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                txslope3# = (txt2# - txt1#) / (iyt2 - iyt1)
                tx# = txt1#
                tyslope3# = (tyt2# - tyt1#) / (iyt2 - iyt1)
                ty# = tyt1#
                cslope4# = (ct2# - ct1#) / (iyt2 - iyt1)
                ct4# = ct1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            IF bilinear THEN
                                xt1 = INT(tx#)
                                yt1 = INT(ty#)
                                xt2 = xt1 + 1
                                yt2 = yt1 + 1
                                col = (image(yt1 AND 63, xt1 AND 63) * (xt2 - tx#) * (yt2 - ty#) + image(yt1 AND 63, xt2 AND 63) * (tx# - xt1) * (yt2 - ty#) + image(yt2 AND 63, xt1 AND 63) * (xt2 - tx#) * (ty# - yt1) + image(yt2 AND 63, xt2 AND 63)  _
* (tx# - xt1) * (ty# - yt1)) * ct4# / 255
                            ELSE
                                col = image(ty# AND 63, tx# AND 63) * ct4# / 255
                            END IF
                            p& = x + mults(y) + offset
                            IF transparent THEN
                                col = col \ 2 + PEEK(p&) '* .75
                                IF col > 255 THEN col = 255
                            END IF
                            POKE p&, col
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    tx# = tx# + txslope3# * dy
                    ty# = ty# + tyslope3# * dy
                    ct4# = ct4# + cslope4# * dy
                NEXT y
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            ct1# = ct1# + cslope1#
            ct2# = ct2# + cslope2#
            txt1# = txt1# + txslope1#
            txt2# = txt2# + txslope2#
            tyt1# = tyt1# + tyslope1#
            tyt2# = tyt2# + tyslope2#
        NEXT
    END IF
    IF x3 > x2 THEN
        yslope2# = (y3 - y2) / xchng3
        yt2# = y2
        izslope2# = (invz3! - invz2!) / xchng3
        iz2# = invz2!
        cslope2# = (c3 - c2) / xchng3
        ct2# = c2
        txslope2# = (tx3! - tx2!) / xchng3
        txt2# = tx2!
        tyslope2# = (ty3! - ty2!) / xchng3
        tyt2# = ty2!
        FOR x = x2 + 1 TO x3
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                txslope3# = (txt2# - txt1#) / (iyt2 - iyt1)
                tx# = txt1#
                tyslope3# = (tyt2# - tyt1#) / (iyt2 - iyt1)
                ty# = tyt1#
                cslope4# = (ct2# - ct1#) / (iyt2 - iyt1)
                ct4# = ct1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            IF bilinear THEN
                                xt1 = INT(tx#)
                                yt1 = INT(ty#)
                                xt2 = xt1 + 1
                                yt2 = yt1 + 1
                                col = (image(yt1 AND 63, xt1 AND 63) * (xt2 - tx#) * (yt2 - ty#) + image(yt1 AND 63, xt2 AND 63) * (tx# - xt1) * (yt2 - ty#) + image(yt2 AND 63, xt1 AND 63) * (xt2 - tx#) * (ty# - yt1) + image(yt2 AND 63, xt2 AND 63)  _
* (tx# - xt1) * (ty# - yt1)) * ct4# / 255
                            ELSE
                                col = image(ty# AND 63, tx# AND 63) * ct4# / 255
                            END IF
                            p& = x + mults(y) + offset
                            IF transparent THEN
                                col = col \ 2 + PEEK(p&) '* .75
                                IF col > 255 THEN col = 255
                            END IF
                            POKE p&, col
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    tx# = tx# + txslope3# * dy
                    ty# = ty# + tyslope3# * dy
                    ct4# = ct4# + cslope4# * dy
                NEXT y
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            ct1# = ct1# + cslope1#
            ct2# = ct2# + cslope2#
            txt1# = txt1# + txslope1#
            txt2# = txt2# + txslope2#
            tyt1# = tyt1# + tyslope1#
            tyt2# = tyt2# + tyslope2#
        NEXT x
    END IF
END IF

END SUB

FUNCTION lineexists (p, p1, p2)

FOR l = 1 TO p - 1
    lp1 = polys(l).p1
    lp2 = polys(l).p2
    lp3 = polys(l).p3
    IF p1 = lp1 THEN
        IF p2 = lp2 OR p2 = lp3 THEN lineexists = 1: EXIT FUNCTION
    ELSEIF p1 = lp2 THEN
        IF p2 = lp1 OR p2 = lp3 THEN lineexists = 1: EXIT FUNCTION
    ELSEIF p1 = lp3 THEN
        IF p2 = lp1 OR p2 = lp2 THEN lineexists = 1: EXIT FUNCTION
    END IF
NEXT l

END FUNCTION

SUB makearccos

REDIM arccos(-256 TO 256) AS INTEGER
FOR a = -256 TO 256
    c1! = 0
    c2! = 360
    DO
        c3! = (c2! + c1!) / 2
        c! = COS(c3! * PI / 180) * 256
        IF c! < a THEN c2! = c3! ELSE c1! = c3!
    LOOP UNTIL c2! - c1! < 1
    arccos(a) = 255 - c3! * 2
    IF arccos(a) < 0 THEN arccos(a) = 0
    'c1 = 0
    'c2 = 360
    'DO
    '    c3 = (c2 + c1) / 2
    '    c = coss(c3) * 256
    '    IF c < a THEN c2 = c3 ELSE c1 = c3
    'LOOP UNTIL c2 - c1 < 2
    'arccos(a) = 255 - c3 * 2
NEXT a

END SUB

SUB makesins

REDIM sins(-360 TO 360) AS SINGLE
REDIM coss(-360 TO 360) AS SINGLE
FOR s = -360 TO 360
    sins(s) = SIN(s * PI / 180)
    coss(s) = COS(s * PI / 180)
NEXT

END SUB

SUB nextpal

SELECT CASE palnum
    CASE 1
        grad 0, 0, 0, 0, 127, 63, 63, 31
        grad 128, 63, 63, 31, 255, 63, 63, 63
    CASE 2
        grad 0, 0, 0, 0, 191, 15, 15, 31
        grad 192, 15, 15, 31, 239, 63, 63, 63
        grad 240, 63, 63, 63, 255, 63, 63, 63
    CASE 3
        grad 0, 0, 0, 0, 63, 63, 0, 0
        grad 64, 63, 0, 0, 191, 63, 63, 0
        grad 192, 63, 63, 0, 255, 63, 63, 63
    CASE ELSE
        grad 0, 0, 0, 0, 255, 63, 63, 63
        'grad 0, 0, 0, 0, 127, 15, 15, 15
        'grad 128, 15, 15, 15, 191, 55, 55, 55
        'grad 192, 55, 55, 55, 255, 63, 63, 63
END SELECT
palnum = (palnum + 1) MOD 4

END SUB

FUNCTION normcol (p)

dot = (lightx * rotnormals(p).x + lighty * rotnormals(p).y + lightz * rotnormals(p).z) / lightmag
normcol = arccos(dot)

END FUNCTION

SUB pal (colour, r, g, b)

OUT &H3C8, colour
OUT &H3C9, r
OUT &H3C9, g
OUT &H3C9, b

END SUB

SUB phong (xp1, yp1, zp1, nxp1!, nyp1!, nzp1!, xp2, yp2, zp2, nxp2!, nyp2!, nzp2!, xp3, yp3, zp3, nxp3!, nyp3!, nzp3!)

'sort by projected x
IF xp1 <= xp2 THEN
    IF xp1 <= xp3 THEN
        x1 = xp1: y1 = yp1: z1 = zp1: nx1! = nxp1!: ny1! = nyp1!: nz1! = nzp1!
        IF xp2 < xp3 THEN
            x2 = xp2: y2 = yp2: z2 = zp2: nx2! = nxp2!: ny2! = nyp2!: nz2! = nzp2!
            x3 = xp3: y3 = yp3: z3 = zp3: nx3! = nxp3!: ny3! = nyp3!: nz3! = nzp3!
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3: nx2! = nxp3!: ny2! = nyp3!: nz2! = nzp3!
            x3 = xp2: y3 = yp2: z3 = zp2: nx3! = nxp2!: ny3! = nyp2!: nz3! = nzp2!
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3: nx1! = nxp3!: ny1! = nyp3!: nz1! = nzp3!
        x2 = xp1: y2 = yp1: z2 = zp1: nx2! = nxp1!: ny2! = nyp1!: nz2! = nzp1!
        x3 = xp2: y3 = yp2: z3 = zp2: nx3! = nxp2!: ny3! = nyp2!: nz3! = nzp2!
    END IF
ELSE
    IF xp2 <= xp3 THEN
        x1 = xp2: y1 = yp2: z1 = zp2: nx1! = nxp2!: ny1! = nyp2!: nz1! = nzp2!
        IF xp1 < xp3 THEN
            x2 = xp1: y2 = yp1: z2 = zp1: nx2! = nxp1!: ny2! = nyp1!: nz2! = nzp1!
            x3 = xp3: y3 = yp3: z3 = zp3: nx3! = nxp3!: ny3! = nyp3!: nz3! = nzp3!
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3: nx2! = nxp3!: ny2! = nyp3!: nz2! = nzp3!
            x3 = xp1: y3 = yp1: z3 = zp1: nx3! = nxp1!: ny3! = nyp1!: nz3! = nzp1!
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3: nx1! = nxp3!: ny1! = nyp3!: nz1! = nzp3!
        x2 = xp2: y2 = yp2: z2 = zp2: nx2! = nxp2!: ny2! = nyp2!: nz2! = nzp2!
        x3 = xp1: y3 = yp1: z3 = zp1: nx3! = nxp1!: ny3! = nyp1!: nz3! = nzp1!
    END IF
END IF

IF x3 = x1 THEN
    EXIT SUB
ELSE
    invz1! = 1 / z1
    invz2! = 1 / z2
    invz3! = 1 / z3
    xchng1 = x3 - x1
    xchng2 = x2 - x1
    xchng3 = x3 - x2
    yslope1# = (y3 - y1) / xchng1
    yt1# = y1
    izslope1# = (invz3! - invz1!) / xchng1
    iz1# = invz1!
    nxslope1# = (nx3! - nx1!) / xchng1
    nxt1# = nx1!
    nyslope1# = (ny3! - ny1!) / xchng1
    nyt1# = ny1!
    nzslope1# = (nz3! - nz1!) / xchng1
    nzt1# = nz1!
    IF x2 > x1 THEN
        yslope2# = (y2 - y1) / xchng2
        yt2# = y1
        izslope2# = (invz2! - invz1!) / xchng2
        iz2# = invz1!
        nxslope2# = (nx2! - nx1!) / xchng2
        nxt2# = nx1!
        nyslope2# = (ny2! - ny1!) / xchng2
        nyt2# = ny1!
        nzslope2# = (nz2! - nz1!) / xchng2
        nzt2# = nz1!
        FOR x = x1 TO x2
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                nxslope3# = (nxt2# - nxt1#) / (iyt2 - iyt1)
                nx# = nxt1#
                nyslope3# = (nyt2# - nyt1#) / (iyt2 - iyt1)
                ny# = nyt1#
                nzslope3# = (nzt2# - nzt1#) / (iyt2 - iyt1)
                nz# = nzt1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        'z = iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            mag# = SQR(nx# * nx# + ny# * ny# + nz# * nz#) / 256
                            IF mag# > .01 THEN
                                nx2# = nx# / mag#
                                ny2# = ny# / mag#
                                nz2# = nz# / mag#
                            END IF
                            dot = (lightx * nx2# + lighty * ny2# + lightz * nz2#) / lightmag
                            col = arccos(dot)
                            'col = 255 - c1 * 2 '1.5
                            IF col < 0 THEN col = 0
                            IF transparent THEN
                                col = col \ 2 + PEEK(p&) * .75
                                IF col > 255 THEN col = 255
                            END IF
                            POKE p&, col
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    nx# = nx# + nxslope3# * dy
                    ny# = ny# + nyslope3# * dy
                    nz# = nz# + nzslope3# * dy
                NEXT y
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            nxt1# = nxt1# + nxslope1#
            nxt2# = nxt2# + nxslope2#
            nyt1# = nyt1# + nyslope1#
            nyt2# = nyt2# + nyslope2#
            nzt1# = nzt1# + nzslope1#
            nzt2# = nzt2# + nzslope2#
        NEXT x
    END IF
    IF x3 > x2 THEN
        yslope2# = (y3 - y2) / xchng3
        yt2# = y2
        izslope2# = (invz3! - invz2!) / xchng3
        iz2# = invz2!
        nxslope2# = (nx3! - nx2!) / xchng3
        nxt2# = nx2!
        nyslope2# = (ny3! - ny2!) / xchng3
        nyt2# = ny2!
        nzslope2# = (nz3! - nz2!) / xchng3
        nzt2# = nz2!
        FOR x = x2 + 1 TO x3
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                nxslope3# = (nxt2# - nxt1#) / (iyt2 - iyt1)
                nx# = nxt1#
                nyslope3# = (nyt2# - nyt1#) / (iyt2 - iyt1)
                ny# = nyt1#
                nzslope3# = (nzt2# - nzt1#) / (iyt2 - iyt1)
                nz# = nzt1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        'z = iz#
                        p& = x + mults(y) + offset
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            mag# = SQR(nx# * nx# + ny# * ny# + nz# * nz#) / 256
                            IF mag# > .01 THEN
                                nx2# = nx# / mag#
                                ny2# = ny# / mag#
                                nz2# = nz# / mag#
                            END IF
                            dot = (lightx * nx2# + lighty * ny2# + lightz * nz2#) / lightmag
                            col = arccos(dot)
                            'col = 255 - c1 * 2 '1.5
                            IF col < 0 THEN col = 0
                            IF transparent THEN
                                col = col \ 2 + PEEK(p&) * .75
                                IF col > 255 THEN col = 255
                            END IF
                            POKE p&, col
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    nx# = nx# + nxslope3# * dy
                    ny# = ny# + nyslope3# * dy
                    nz# = nz# + nzslope3# * dy
                NEXT
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            nxt1# = nxt1# + nxslope1#
            nxt2# = nxt2# + nxslope2#
            nyt1# = nyt1# + nyslope1#
            nyt2# = nyt2# + nyslope2#
            nzt1# = nzt1# + nzslope1#
            nzt2# = nzt2# + nzslope2#
        NEXT x
    END IF
END IF

END SUB

SUB pointnormalunits

FOR p = 1 TO numpoints
    mag! = SQR(rotpointnormals(p).x ^ 2 + rotpointnormals(p).y ^ 2 + rotpointnormals(p).z ^ 2)
    IF mag! > 0 THEN
        'enviropointnormals(p).x = rotpointnormals(p).x / mag!
        'enviropointnormals(p).y = rotpointnormals(p).y / mag!
        'enviropointnormals(p).z = rotpointnormals(p).z / mag!
        enviropointnormals(p).x = 16 * rotpointnormals(p).x / mag! + 32
        enviropointnormals(p).y = 16 * rotpointnormals(p).y / mag! + 32
        enviropointnormals(p).z = 16 * rotpointnormals(p).z / mag! + 32
    END IF
NEXT p

END SUB

FUNCTION pointnormcol (p)

dot = (lightx * rotpointnormals(p).x + lighty * rotpointnormals(p).y + lightz * rotpointnormals(p).z) / lightmag
pointnormcol = arccos(dot)

END FUNCTION

FUNCTION pointvis (p)

IF rotpointnormals(p).z > 0 THEN
    pointvis = 0
ELSE
    pointvis = 1
END IF

END FUNCTION

FUNCTION polyvis (p)

x1 = projpoints(polys(p).p1).x
y1 = projpoints(polys(p).p1).y
x2 = projpoints(polys(p).p2).x
y2 = projpoints(polys(p).p2).y
x3 = projpoints(polys(p).p3).x
y3 = projpoints(polys(p).p3).y
IF 1& * (y1 - y2) * (x2 - x3) > 1& * (x1 - x2) * (y2 - y3) THEN polyvis = 1

END FUNCTION

SUB pset3d (x, y)

IF x > -1 AND x < 320 AND y > -1 AND y < 200 THEN
    POKE offset + mults(y) + x, 255
END IF

END SUB

SUB pseta3d (x!, y!, z!)

xp! = x! * zoom / (z! + distance) + 160
yp! = y! * zoom / (z! + distance) + 100

x1 = FIX(xp!)
x2 = x1 + 1
y1 = FIX(yp!)
y2 = y1 + 1
IF x2 > 0 AND x1 < 319 AND y2 > 0 AND y1 < 199 THEN
    p1& = mults(y1) + offset + x1
    p2& = p1& + 320
    m1! = (x2 - xp!) * (y2 - yp!)
    m2! = (xp! - x1) * (y2 - yp!)
    m3! = (x2 - xp!) * (yp! - y1)
    m4! = (xp! - x1) * (yp! - y1)
    col1 = 255 * m1! + PEEK(p1&)
    col2 = 255 * m2! + PEEK(p1& + 1)
    col3 = 255 * m3! + PEEK(p2&)
    col4 = 255 * m4! + PEEK(p2& + 1)
    IF col1 > 255 THEN col1 = 255
    IF col2 > 255 THEN col2 = 255
    IF col3 > 255 THEN col3 = 255
    IF col4 > 255 THEN col4 = 255
    POKE p1&, col1
    POKE p1& + 1, col2
    POKE p2&, col3
    POKE p2& + 1, col4
END IF

END SUB

SUB ptmap (xp1, yp1, zp1!, tpx1!, tpy1!, xp2, yp2, zp2!, tpx2!, tpy2!, xp3, yp3, zp3!, tpx3!, tpy3!)

'sort by projected x
IF xp1 <= xp2 THEN
    IF xp1 <= xp3 THEN
        x1 = xp1: y1 = yp1: z1! = zp1!: tx1! = tpx1!: ty1! = tpy1!
        IF xp2 < xp3 THEN
            x2 = xp2: y2 = yp2: z2! = zp2!: tx2! = tpx2!: ty2! = tpy2!
            x3 = xp3: y3 = yp3: z3! = zp3!: tx3! = tpx3!: ty3! = tpy3!
        ELSE
            x2 = xp3: y2 = yp3: z2! = zp3!: tx2! = tpx3!: ty2! = tpy3!
            x3 = xp2: y3 = yp2: z3! = zp2!: tx3! = tpx2!: ty3! = tpy2!
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1! = zp3!: tx1! = tpx3!: ty1! = tpy3!
        x2 = xp1: y2 = yp1: z2! = zp1!: tx2! = tpx1!: ty2! = tpy1!
        x3 = xp2: y3 = yp2: z3! = zp2!: tx3! = tpx2!: ty3! = tpy2!
    END IF
ELSE
    IF xp2 <= xp3 THEN
        x1 = xp2: y1 = yp2: z1! = zp2!: tx1! = tpx2!: ty1! = tpy2!
        IF xp1 < xp3 THEN
            x2 = xp1: y2 = yp1: z2! = zp1!: tx2! = tpx1!: ty2! = tpy1!
            x3 = xp3: y3 = yp3: z3! = zp3!: tx3! = tpx3!: ty3! = tpy3!
        ELSE
            x2 = xp3: y2 = yp3: z2! = zp3!: tx2! = tpx3!: ty2! = tpy3!
            x3 = xp1: y3 = yp1: z3! = zp1!: tx3! = tpx1!: ty3! = tpy1!
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1! = zp3!: tx1! = tpx3!: ty1! = tpy3!
        x2 = xp2: y2 = yp2: z2! = zp2!: tx2! = tpx2!: ty2! = tpy2!
        x3 = xp1: y3 = yp1: z3! = zp1!: tx3! = tpx1!: ty3! = tpy1!
    END IF
END IF

IF x3 = x1 THEN
    EXIT SUB
ELSE
    invz1! = 1 / z1!
    invz2! = 1 / z2!
    invz3! = 1 / z3!
    invtx1! = tx1! * invz1!
    invtx2! = tx2! * invz2!
    invtx3! = tx3! * invz3!
    invty1! = ty1! * invz1!
    invty2! = ty2! * invz2!
    invty3! = ty3! * invz3!
    dx# = 1 / (x3 - x1)
    yslope1# = (y3 - y1) * dx#
    yt1# = y1
    izslope1# = (invz3! - invz1!) * dx#
    iz1# = invz1!
    itxslope1# = (invtx3! - invtx1!) * dx#
    itx1# = invtx1!
    ityslope1# = (invty3! - invty1!) * dx#
    ity1# = invty1!
    IF x2 > x1 THEN
        dx# = 1 / (x2 - x1)
        yslope2# = (y2 - y1) * dx#
        yt2# = y1
        izslope2# = (invz2! - invz1!) * dx#
        iz2# = invz1!
        itxslope2# = (invtx2! - invtx1!) * dx#
        itx2# = invtx1!
        ityslope2# = (invty2! - invty1!) * dx#
        ity2# = invty1!
        FOR x = x1 TO x2
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                diyt# = 1 / (iyt2 - iyt1)
                izslope3# = (iz2# - iz1#) * diyt#
                iz# = iz1#
                itxslope3# = (itx2# - itx1#) * diyt#
                itx# = itx1#
                ityslope3# = (ity2# - ity1#) * diyt#
                ity# = ity1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z# = 1 / iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z# OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z#
                            DEF SEG = segment
                            tx# = itx# * z#
                            ty# = ity# * z#
                            IF bilinear THEN
                                xt1 = INT(tx#)
                                yt1 = INT(ty#)
                                xt2 = xt1 + 1
                                yt2 = yt1 + 1
                                col = image(yt1 AND 63, xt1 AND 63) * (xt2 - tx#) * (yt2 - ty#) + image(yt1 AND 63, xt2 AND 63) * (tx# - xt1) * (yt2 - ty#) + image(yt2 AND 63, xt1 AND 63) * (xt2 - tx#) * (ty# - yt1) + image(yt2 AND 63, xt2 AND 63) * _
 (tx# - xt1) * (ty# - yt1)
                            ELSE
                                col = image(ty# AND 63, tx# AND 63)
                            END IF
                            IF transparent THEN
                                col = col \ 2 + PEEK(p&) * .75
                                IF col > 255 THEN col = 255
                            END IF
                            POKE p&, col
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    itx# = itx# + itxslope3# * dy
                    ity# = ity# + ityslope3# * dy
                NEXT y
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            itx1# = itx1# + itxslope1#
            itx2# = itx2# + itxslope2#
            ity1# = ity1# + ityslope1#
            ity2# = ity2# + ityslope2#
        NEXT x
    END IF
    IF x3 > x2 THEN
        dx# = 1 / (x3 - x2)
        yslope2# = (y3 - y2) * dx#
        yt2# = y2
        izslope2# = (invz3! - invz2!) * dx#
        iz2# = invz2!
        itxslope2# = (invtx3! - invtx2!) * dx#
        itx2# = invtx2!
        ityslope2# = (invty3! - invty2!) * dx#
        ity2# = invty2!
        FOR x = x2 + 1 TO x3
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                diyt# = 1 / (iyt2 - iyt1)
                izslope3# = (iz2# - iz1#) * diyt#
                iz# = iz1#
                itxslope3# = (itx2# - itx1#) * diyt#
                itx# = itx1#
                ityslope3# = (ity2# - ity1#) * diyt#
                ity# = ity1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z# = 1 / iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z# OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z#
                            DEF SEG = segment
                            tx# = itx# * z#
                            ty# = ity# * z#
                            IF bilinear THEN
                                xt1 = INT(tx#)
                                yt1 = INT(ty#)
                                xt2 = xt1 + 1
                                yt2 = yt1 + 1
                                col = image(yt1 AND 63, xt1 AND 63) * (xt2 - tx#) * (yt2 - ty#) + image(yt1 AND 63, xt2 AND 63) * (tx# - xt1) * (yt2 - ty#) + image(yt2 AND 63, xt1 AND 63) * (xt2 - tx#) * (ty# - yt1) + image(yt2 AND 63, xt2 AND 63) * _
 (tx# - xt1) * (ty# - yt1)
                            ELSE
                                col = image(ty# AND 63, tx# AND 63)
                            END IF
                            IF transparent THEN
                                col = col \ 2 + PEEK(p&) * .75
                                IF col > 255 THEN col = 255
                            END IF
                            POKE p&, col
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    itx# = itx# + itxslope3# * dy
                    ity# = ity# + ityslope3# * dy
                NEXT
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            itx1# = itx1# + itxslope1#
            itx2# = itx2# + itxslope2#
            ity1# = ity1# + ityslope1#
            ity2# = ity2# + ityslope2#
        NEXT x
    END IF
END IF

END SUB

SUB Quiksort (min, max)

IF min < max THEN
    p1 = min
    p2 = max
    mid = avezs((min + max) \ 2)
    DO UNTIL p1 > p2
        DO WHILE avezs(p1) > mid
            p1 = p1 + 1
        LOOP
        DO WHILE mid > avezs(p2)
            p2 = p2 - 1
        LOOP
        IF p1 <= p2 THEN
            SWAP polys(p1), polys(p2)
            SWAP normals(p1), normals(p2)
            SWAP rotnormals(p1), rotnormals(p2)
            SWAP avezs(p1), avezs(p2)
            p1 = p1 + 1
            p2 = p2 - 1
        END IF
    LOOP
    IF min < p2 THEN Quiksort min, p2
    IF p1 < max THEN Quiksort p1, max
END IF

END SUB

SUB ReadPlgHeader (file$)

OPEN file$ FOR INPUT AS 1
LINE INPUT #1, lbuf$
lbuf$ = LTRIM$(lbuf$)
objectname$ = LEFT$(lbuf$, INSTR(lbuf$, " "))
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - INSTR(lbuf$, " "))
lbuf$ = LTRIM$(lbuf$)
numpoints = VAL(LEFT$(lbuf$, INSTR(lbuf$, " ")))
lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - INSTR(lbuf$, " "))
lbuf$ = LTRIM$(lbuf$)
numpolys = VAL(lbuf$)

FOR p = 1 TO numpoints
    LINE INPUT #1, lbuf$
NEXT p
np = numpolys
FOR p = 1 TO np
    LINE INPUT #1, lbuf$
    lbuf$ = LTRIM$(lbuf$)
    lps = INSTR(lbuf$, " ")
    nop = VAL(LEFT$(lbuf$, lps))
    lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
    lbuf$ = LTRIM$(lbuf$)
    lps = INSTR(lbuf$, " ")
    nop = VAL(LEFT$(lbuf$, lps))
    IF nop = 4 THEN
        numpolys = numpolys + 1
    END IF
NEXT p

CLOSE

END SUB

SUB ReadPlgObject (file$)

OPEN file$ FOR INPUT AS 1
LINE INPUT #1, lbuf$
FOR p = 1 TO numpoints
    LINE INPUT #1, lbuf$
    lbuf$ = LTRIM$(lbuf$)
    lps = INSTR(lbuf$, " ")
    points(p).x = VAL(LEFT$(lbuf$, lps))
    lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
    lbuf$ = LTRIM$(lbuf$)
    lps = INSTR(lbuf$, " ")
    points(p).z = VAL(LEFT$(lbuf$, lps))
    lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
    lbuf$ = LTRIM$(lbuf$)
    lps = INSTR(lbuf$, " ")
    IF lps THEN
        points(p).y = VAL(LEFT$(lbuf$, lps))
    ELSE
        points(p).y = VAL(lbuf$)
    END IF
NEXT p

FOR p = 1 TO numpolys
    LINE INPUT #1, lbuf$
    lbuf$ = LTRIM$(lbuf$)
    lps = INSTR(lbuf$, " ")
    nop = VAL(LEFT$(lbuf$, lps))
    lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
    lbuf$ = LTRIM$(lbuf$)
    lps = INSTR(lbuf$, " ")
    nop = VAL(LEFT$(lbuf$, lps))
    IF nop = 4 THEN
        lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
        lbuf$ = LTRIM$(lbuf$)
        lps = INSTR(lbuf$, " ")
        p1 = VAL(LEFT$(lbuf$, lps)) + 1
        lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
        lbuf$ = LTRIM$(lbuf$)
        lps = INSTR(lbuf$, " ")
        p2 = VAL(LEFT$(lbuf$, lps)) + 1
        lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
        lbuf$ = LTRIM$(lbuf$)
        lps = INSTR(lbuf$, " ")
        p3 = VAL(LEFT$(lbuf$, lps)) + 1
        lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
        lbuf$ = LTRIM$(lbuf$)
        lps = INSTR(lbuf$, " ")
        p4 = VAL(lbuf$) + 1
        polys(p).p1 = p1
        polys(p).p2 = p2
        polys(p).p3 = p4
        p = p + 1
        polys(p).p1 = p2
        polys(p).p2 = p3
        polys(p).p3 = p4
    ELSE
        lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
        lbuf$ = LTRIM$(lbuf$)
        lps = INSTR(lbuf$, " ")
        polys(p).p1 = VAL(LEFT$(lbuf$, lps)) + 1
        lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
        lbuf$ = LTRIM$(lbuf$)
        lps = INSTR(lbuf$, " ")
        polys(p).p2 = VAL(LEFT$(lbuf$, lps)) + 1
        lbuf$ = RIGHT$(lbuf$, LEN(lbuf$) - lps)
        lbuf$ = LTRIM$(lbuf$)
        lps = INSTR(lbuf$, " ")
        polys(p).p3 = VAL(lbuf$) + 1
    END IF
NEXT p
CLOSE

END SUB

SUB rotatenormals

'IF dxr = 0 AND dyr = 0 AND dzr = 0 THEN EXIT SUB
FOR p = 1 TO numpolys
    x! = normals(p).x
    y! = normals(p).y
    z! = normals(p).z
    rotnormals(p).x = x! * cubex1 + y! * cubex2 + z! * cubex3
    rotnormals(p).y = x! * cubey1 + y! * cubey2 + z! * cubey3
    rotnormals(p).z = x! * cubez1 + y! * cubez2 + z! * cubez3
NEXT p

END SUB

SUB rotatepointnormals

'IF dxr = 0 AND dyr = 0 AND dzr = 0 THEN EXIT SUB
FOR p = 1 TO numpoints
    x! = pointnormals(p).x
    y! = pointnormals(p).y
    z! = pointnormals(p).z
    rotpointnormals(p).x = x! * cubex1 + y! * cubex2 + z! * cubex3
    rotpointnormals(p).y = x! * cubey1 + y! * cubey2 + z! * cubey3
    rotpointnormals(p).z = x! * cubez1 + y! * cubez2 + z! * cubez3
NEXT p

END SUB

SUB rotatepoints

'IF dxr = 0 AND dyr = 0 AND dzr = 0 THEN EXIT SUB
FOR p = 1 TO numpoints
    x! = points(p).x
    y! = points(p).y
    z! = points(p).z
    xr! = x! * cubex1 + y! * cubex2 + z! * cubex3
    yr! = x! * cubey1 + y! * cubey2 + z! * cubey3
    zr! = x! * cubez1 + y! * cubez2 + z! * cubez3
    rotpoints(p).x = xr!
    rotpoints(p).y = yr!
    rotpoints(p).z = zr!
    projpoints(p).x = zoom * xr! \ (zr! + distance) + 160
    projpoints(p).y = zoom * yr! \ (zr! + distance) + 100
NEXT p

END SUB

SUB tmap (xp1, yp1, zp1, tpx1!, tpy1!, xp2, yp2, zp2, tpx2!, tpy2!, xp3, yp3, zp3, tpx3!, tpy3!)

'sort by projected x
IF xp1 <= xp2 THEN
    IF xp1 <= xp3 THEN
        x1 = xp1: y1 = yp1: z1 = zp1: tx1! = tpx1!: ty1! = tpy1!
        IF xp2 < xp3 THEN
            x2 = xp2: y2 = yp2: z2 = zp2: tx2! = tpx2!: ty2! = tpy2!
            x3 = xp3: y3 = yp3: z3 = zp3: tx3! = tpx3!: ty3! = tpy3!
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3: tx2! = tpx3!: ty2! = tpy3!
            x3 = xp2: y3 = yp2: z3 = zp2: tx3! = tpx2!: ty3! = tpy2!
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3: tx1! = tpx3!: ty1! = tpy3!
        x2 = xp1: y2 = yp1: z2 = zp1: tx2! = tpx1!: ty2! = tpy1!
        x3 = xp2: y3 = yp2: z3 = zp2: tx3! = tpx2!: ty3! = tpy2!
    END IF
ELSE
    IF xp2 <= xp3 THEN
        x1 = xp2: y1 = yp2: z1 = zp2: tx1! = tpx2!: ty1! = tpy2!
        IF xp1 < xp3 THEN
            x2 = xp1: y2 = yp1: z2 = zp1: tx2! = tpx1!: ty2! = tpy1!
            x3 = xp3: y3 = yp3: z3 = zp3: tx3! = tpx3!: ty3! = tpy3!
        ELSE
            x2 = xp3: y2 = yp3: z2 = zp3: tx2! = tpx3!: ty2! = tpy3!
            x3 = xp1: y3 = yp1: z3 = zp1: tx3! = tpx1!: ty3! = tpy1!
        END IF
    ELSE
        x1 = xp3: y1 = yp3: z1 = zp3: tx1! = tpx3!: ty1! = tpy3!
        x2 = xp2: y2 = yp2: z2 = zp2: tx2! = tpx2!: ty2! = tpy2!
        x3 = xp1: y3 = yp1: z3 = zp1: tx3! = tpx1!: ty3! = tpy1!
    END IF
END IF

IF x3 = x1 THEN
    EXIT SUB
ELSE
    invz1! = 1 / z1
    invz2! = 1 / z2
    invz3! = 1 / z3
    xchng1 = x3 - x1
    xchng2 = x2 - x1
    xchng3 = x3 - x2
    yslope1# = (y3 - y1) / xchng1
    yt1# = y1
    izslope1# = (invz3! - invz1!) / xchng1
    iz1# = invz1!
    txslope1# = (tx3! - tx1!) / xchng1
    txt1# = tx1!
    tyslope1# = (ty3! - ty1!) / xchng1
    tyt1# = ty1!
    IF x2 > x1 THEN
        yslope2# = (y2 - y1) / xchng2
        yt2# = y1
        izslope2# = (invz2! - invz1!) / xchng2
        iz2# = invz1!
        txslope2# = (tx2! - tx1!) / xchng2
        txt2# = tx1!
        tyslope2# = (ty2! - ty1!) / xchng2
        tyt2# = ty1!
        FOR x = x1 TO x2
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                txslope3# = (txt2# - txt1#) / (iyt2 - iyt1)
                tx# = txt1#
                tyslope3# = (tyt2# - tyt1#) / (iyt2 - iyt1)
                ty# = tyt1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            IF bilinear THEN
                                xt1 = INT(tx#)
                                yt1 = INT(ty#)
                                xt2 = xt1 + 1
                                yt2 = yt1 + 1
                                col = image(yt1 AND 63, xt1 AND 63) * (xt2 - tx#) * (yt2 - ty#) + image(yt1 AND 63, xt2 AND 63) * (tx# - xt1) * (yt2 - ty#) + image(yt2 AND 63, xt1 AND 63) * (xt2 - tx#) * (ty# - yt1) + image(yt2 AND 63, xt2 AND 63) * _
 (tx# - xt1) * (ty# - yt1)
                            ELSE
                                col = image(ty# AND 63, tx# AND 63)
                            END IF
                            IF transparent THEN
                                col = col \ 2 + PEEK(p&) * .75
                                IF col > 255 THEN col = 255
                            END IF
                            POKE p&, col
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    tx# = tx# + txslope3# * dy
                    ty# = ty# + tyslope3# * dy
                NEXT
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            txt1# = txt1# + txslope1#
            txt2# = txt2# + txslope2#
            tyt1# = tyt1# + tyslope1#
            tyt2# = tyt2# + tyslope2#
        NEXT
    END IF
    IF x3 > x2 THEN
        yslope2# = (y3 - y2) / xchng3
        yt2# = y2
        izslope2# = (invz3! - invz2!) / xchng3
        iz2# = invz2!
        txslope2# = (tx3! - tx2!) / xchng3
        txt2# = tx2!
        tyslope2# = (ty3! - ty2!) / xchng3
        tyt2# = ty2!
        FOR x = x2 + 1 TO x3
            iyt1 = CINT(yt1#)
            iyt2 = CINT(yt2#)
            dy = SGN(iyt2 - iyt1)
            IF dy THEN
                izslope3# = (iz2# - iz1#) / (iyt2 - iyt1)
                iz# = iz1#
                txslope3# = (txt2# - txt1#) / (iyt2 - iyt1)
                tx# = txt1#
                tyslope3# = (tyt2# - tyt1#) / (iyt2 - iyt1)
                ty# = tyt1#
                FOR y = iyt1 TO iyt2 STEP dy
                    IF (y > 199 AND dy = 1) OR (y < 0 AND dy = -1) THEN EXIT FOR
                    IF y < 200 AND y > -1 THEN
                        z = 1 / iz#
                        p& = x + mults(y) + zoff
                        DEF SEG = zseg
                        IF PEEK(p&) > z OR PEEK(p&) = 0 OR transparent THEN
                            POKE p&, z
                            DEF SEG = segment
                            IF bilinear THEN
                                xt1 = INT(tx#)
                                yt1 = INT(ty#)
                                xt2 = xt1 + 1
                                yt2 = yt1 + 1
                                col = image(yt1 AND 63, xt1 AND 63) * (xt2 - tx#) * (yt2 - ty#) + image(yt1 AND 63, xt2 AND 63) * (tx# - xt1) * (yt2 - ty#) + image(yt2 AND 63, xt1 AND 63) * (xt2 - tx#) * (ty# - yt1) + image(yt2 AND 63, xt2 AND 63) * _
 (tx# - xt1) * (ty# - yt1)
                            ELSE
                                col = image(ty# AND 63, tx# AND 63)
                            END IF
                            IF transparent THEN
                                col = col \ 2 + PEEK(p&) * .75
                                IF col > 255 THEN col = 255
                            END IF
                            POKE p&, col
                        ELSE
                            DEF SEG = segment
                        END IF
                    END IF
                    iz# = iz# + izslope3# * dy
                    tx# = tx# + txslope3# * dy
                    ty# = ty# + tyslope3# * dy
                NEXT
            END IF
            yt1# = yt1# + yslope1#
            yt2# = yt2# + yslope2#
            iz1# = iz1# + izslope1#
            iz2# = iz2# + izslope2#
            txt1# = txt1# + txslope1#
            txt2# = txt2# + txslope2#
            tyt1# = tyt1# + tyslope1#
            tyt2# = tyt2# + tyslope2#
        NEXT x
    END IF
END IF

END SUB

SUB zsort

'IF dxr = 0 AND dyr = 0 AND dzr = 0 THEN EXIT SUB
FOR p = 1 TO numpolys
    avezs(p) = (rotpoints(polys(p).p1).z + rotpoints(polys(p).p2).z + rotpoints(polys(p).p3).z) \ 3
NEXT p

Quiksort 1, numpolys

'FOR p = 1 TO numpolys - 1
'    z = avezs(p)
'    pbest = p
'    bestz = z
'    FOR p2 = p + 1 TO numpolys
'        z = avezs(p2)
'        IF z > bestz THEN
'            bestz = z
'            pbest = p2
'        END IF
'    NEXT p2
'    SWAP polys(p), polys(pbest)
'    SWAP normals(p), normals(pbest)
'    SWAP rotnormals(p), rotnormals(pbest)
'    SWAP avezs(p), avezs(pbest)
'NEXT p

END SUB

