DECLARE SUB lightenviromap (xp1%, yp1%, tpx1!, tpy1!, col1%, xp2%, yp2%, tpx2!, tpy2!, col2%, xp3%, yp3%, tpx3!, tpy3!, col3%)
DECLARE SUB alightenviromap (xp1%, yp1%, tpx1!, tpy1!, col1%, xp2%, yp2%, tpx2!, tpy2!, col2%, xp3%, yp3%, tpx3!, tpy3!, col3%)
DECLARE SUB alighttmap (xp1%, yp1%, tpx1%, tpy1%, col1%, xp2%, yp2%, tpx2%, tpy2%, col2%, xp3%, yp3%, tpx3%, tpy3%, col3%)
DECLARE SUB lighttmap (xp1%, yp1%, tpx1%, tpy1%, col1%, xp2%, yp2%, tpx2%, tpy2%, col2%, xp3%, yp3%, tpx3%, tpy3%, col3%)
DECLARE SUB aenviromap (xp1%, yp1%, tpx1!, tpy1!, xp2%, yp2%, tpx2!, tpy2!, xp3%, yp3%, tpx3!, tpy3!)
DECLARE SUB enviromap (xp1%, yp1%, tpx1!, tpy1!, xp2%, yp2%, tpx2!, tpy2!, xp3%, yp3%, tpx3!, tpy3!)
DECLARE SUB pointnormalunits ()
DECLARE SUB atmap (xp1%, yp1%, tpx1%, tpy1%, xp2%, yp2%, tpx2%, tpy2%, xp3%, yp3%, tpx3%, tpy3%)
DECLARE SUB baline (xx1%, yy1%, xx2%, yy2%, col%)
DECLARE SUB aline3d (x1%, y1%, x2%, y2%, x3%, y3%, col%)
DECLARE SUB line3d (x1%, y1%, x2%, y2%, x3%, y3%, col%)
DECLARE SUB pseta3d (x!, y!, z!)
DECLARE SUB pset3d (x%, y%)
DECLARE SUB Inittmap ()
DECLARE SUB tmap (xp1%, yp1%, tpx1%, tpy1%, xp2%, yp2%, tpx2%, tpy2%, xp3%, yp3%, tpx3%, tpy3%)
DECLARE SUB nextpal ()
DECLARE FUNCTION pointvis% (p%)
DECLARE FUNCTION polyvis% (p%)
DECLARE SUB gouraudshade (x1%, y1%, c1%, x2%, y2%, c2%, x3%, y3%, c3%)
DECLARE FUNCTION pointnormcol% (p%)
DECLARE SUB rotatepointnormals ()
DECLARE SUB CalcPointNormals ()
DECLARE SUB rotatenormals ()
DECLARE SUB rotatepoints ()
DECLARE SUB zsort ()
DECLARE FUNCTION normcol% (p%)
DECLARE SUB CalcNormals ()
DECLARE SUB flatshade (xp1%, yp1%, xp2%, yp2%, xp3%, yp3%, col%)
DECLARE SUB clearbuf ()
DECLARE SUB bline (xx1%, yy1%, xx2%, yy2%, col%)
DECLARE SUB feedback ()
DECLARE SUB blur ()
DECLARE SUB CenterObject (maxo%)
DECLARE SUB ReadPlgHeader (file$)
DECLARE SUB ReadPlgObject (file$)
DECLARE SUB grad (col1%, r1%, g1%, b1%, col2%, r2%, g2%, b2%)
DECLARE SUB pal (colour%, r%, g%, b%)
DECLARE SUB makesins ()
DECLARE FUNCTION transpointcol% (p%)
DECLARE FUNCTION transcol% (p%)

TYPE p3d            'defines a point in 3d
    x AS SINGLE
    y AS SINGLE
    z AS SINGLE
END TYPE

TYPE p2d            'defines a point in 2d
    x AS INTEGER
    y AS INTEGER
END TYPE

TYPE poly           'defines a 3-gon in 3d
    p1 AS INTEGER
    p2 AS INTEGER
    p3 AS INTEGER
END TYPE

TYPE pline          'defines a line in 3d (not used)
    p1 AS INTEGER
    p2 AS INTEGER
END TYPE

DEFINT A-Z

COMMON SHARED points() AS p3d               'each point
COMMON SHARED rotpoints() AS p3d            'each point, rotated
COMMON SHARED pointnormals() AS p3d         'each point's normal
COMMON SHARED rotpointnormals() AS p3d      'each point's rotated normal
COMMON SHARED enviropointnormals() AS p3d   'each point's rotated unit normal
COMMON SHARED polys() AS poly               'each polygon
COMMON SHARED normals() AS p3d              'each polygon's normal
COMMON SHARED rotnormals() AS p3d           'each polygon's rotated normal
COMMON SHARED tmpoints() AS p3d             'each point's tmap point
COMMON SHARED projpoints() AS p2d           'each rotated point's projection
COMMON SHARED lines() AS pline              'each line (not used)
COMMON SHARED avezs() AS INTEGER            'average z-coordinate of poly
COMMON SHARED buffer() AS INTEGER           'buffer
COMMON SHARED image() AS INTEGER            'texture

CONST PI = 3.1415926#

CONST doblur = 1        'blur
CONST dofeedback = 2    'feedback
CONST mpoints = 1       'point
CONST mapoints = 2      'bilinear points
CONST mlines = 3        'wireframe
CONST malines = 4       'antialaised wireframe
CONST mflat = 5         'flatshade
CONST mgouraud = 6      'gouraud shade
CONST mtmap = 7         'texture map
CONST matmap = 8        'bilinear texture map
CONST menviro = 9       'enviroment map
CONST maenviro = 0      'bilinear enviroment map
CONST mltmap = 10       'gourauded texture map
CONST maltmap = 11      'bilinear gourauded texture map
CONST mlenviro = 12     'gourauded enviroment map
CONST malenviro = 13    'bilinear gourauded enviroment map

COMMON SHARED objectname$              'name of object
COMMON SHARED numpoints AS INTEGER     'number of points
COMMON SHARED numpolys AS INTEGER      'number of polygons
COMMON SHARED numlines AS INTEGER      'number of lines (not used)

COMMON SHARED distance AS INTEGER          'distance to camera
COMMON SHARED zoom AS INTEGER              'zoom
COMMON SHARED xrot AS INTEGER              'x-rotation
COMMON SHARED yrot AS INTEGER              'y-rotation
COMMON SHARED zrot AS INTEGER              'z-rotation
COMMON SHARED sins() AS DOUBLE              'pre-calced sines
COMMON SHARED coss() AS DOUBLE              'pre-calced cosines
COMMON SHARED divs() AS INTEGER             'pre-calced blur divisions
COMMON SHARED mults() AS LONG               'pre-calced multiplications

COMMON SHARED segment AS INTEGER
COMMON SHARED offset AS INTEGER
COMMON SHARED cubex1 AS DOUBLE         'control cube coordinates
COMMON SHARED cubey1 AS DOUBLE         '|
COMMON SHARED cubez1 AS DOUBLE         '|
COMMON SHARED cubex2 AS DOUBLE         '|
COMMON SHARED cubey2 AS DOUBLE         '|
COMMON SHARED cubez2 AS DOUBLE         '|
COMMON SHARED cubex3 AS DOUBLE         '|
COMMON SHARED cubey3 AS DOUBLE         '|
COMMON SHARED cubez3 AS DOUBLE         '|

COMMON SHARED lightx AS DOUBLE         'lightsource coordinates
COMMON SHARED lighty AS DOUBLE         '|
COMMON SHARED lightz AS DOUBLE         '|
COMMON SHARED lightmag AS DOUBLE       'lightsource magnitude
COMMON SHARED mode AS INTEGER          'rendering mode
COMMON SHARED effect AS INTEGER        'effect mode
COMMON SHARED transparent AS INTEGER   'transparency on/off
COMMON SHARED movelight AS INTEGER     'moving light-source on/off
COMMON SHARED file$                    'filename
COMMON SHARED palnum AS INTEGER        'palette number

